from random import randint, seed
seed(47)

def save(fname, H, D):
    f = open( fname, 'w' )
    print( len(H), D, file=f )
    print( *H, file=f )
    f.close()

save('0.sample.in', [20,30,50,30], 100)

for tc in 'abcde':
    N = randint(10,16)
    H = [ randint(1,1000) for n in range(N) ]
    D = randint(1500,3000)
    save('1.'+tc+'.in', H, D)

save('1.f.in', [47], 47)

N = 50
H = [ randint(1,1000) for n in range(N) ]
save('2.a.in', H, 1000)
save('2.b.in', H, 1070)
N = 47
H = [ randint(1,1000) for n in range(N) ]
save('2.c.in', H, 1000)
save('2.d.in', H, 1250)

for tc in 'abcde':
    N = randint(900,1000)
    H = [ randint(1,10**6) for n in range(N) ]
    D = randint(max(H),sum(H)-1)
    save('3.'+tc+'.in', H, D)

for tc in 'abcde':
    N = randint(90000,100000)
    D = randint(2,10)
    if tc == 'a': D = 1
    H = [ randint(1,D) for n in range(N) ]
    save('4.'+tc+'.in', H, D)

N = randint(490000,500000)
H = [ randint(1,10**9 // 500000) for n in range(N) ]
D = randint(max(H),sum(H)-1)
save('5.a.in', H, D)

N = randint(490000,500000)
H = [ randint(1,10**9) for n in range(N) ]
D = randint(max(H),10**9)
save('5.b.in', H, D)

N = randint(490000,500000)
H = [ randint(1,10**6) for n in range(N) ]
D = randint(10**8,10**9)
save('5.c.in', H, D)
