#include <bits/stdc++.h>
using namespace std;

const int MOD = 1000000007;

int uprav(int x) {
    if (x < 0) x += MOD;
    if (x >= MOD) x -= MOD;
    return x;
}

long long rataj(int schod, int D, const vector<long long> &V) {
    if (schod == 0) return 1;
    long long odpoved = 0;
    for (int prev=schod-1; prev>=0; --prev) {
        if (V[schod] - V[prev] > D) break;
        odpoved += rataj(prev, D, V);
    }
    return odpoved;
}

int main() {
    int N, D;
    cin >> N >> D;
    vector<int> H(N);
    for (int &h : H) cin >> h;

    // vypocitame vysky v ktorych su jednotlive schody
    vector<long long> V = {0};
    for (int h : H) V.push_back( V.back()+h );
    
    // rekurzivne vyskusame vsetky cesty hore
    cout << rataj(N,D,V) << endl;
}
