#include <bits/stdc++.h>
using namespace std;

const int MOD = 1000000007;

int uprav(int x) {
    if (x < 0) x += MOD;
    if (x >= MOD) x -= MOD;
    return x;
}

int main() {
    int N, D;
    cin >> N >> D;
    vector<int> H(N);
    for (int &h : H) cin >> h;

    // vypocitame vysky v ktorych su jednotlive schody
    vector<long long> V = {0};
    for (int h : H) V.push_back( V.back()+h );

    // pre kazdy schod vypocitame prvy z ktoreho nan mozeme ist
    vector<int> M = {0,0};
    for (int a=2, b=0; a<=N; ++a) {
        while (V[a] - V[b] > D) ++b;
        M.push_back(b);
    }

    // postupne pocitame odpovede a aj ich prefixove sucty
    vector<int> P = {1}, S = {0,1};
    for (int i=1; i<=N; ++i) {
        P.push_back( uprav( S[i] - S[M[i]] ) );
        S.push_back( uprav( S.back() + P.back() ) );
    }
    cout << P[N] << endl;
}
