from re import match
from sys import stdin

data = stdin.readlines()
assert len(data) == 2

assert match(r'^[1-9][0-9]* [1-9][0-9]*\n$', data[0])
N, D = [ int(x) for x in data[0].split() ]

assert match(r'^[1-9][0-9]*( [1-9][0-9]*)*\n$', data[1])
H = [ int(x) for x in data[1].split() ]

assert len(H) == N

for h in H: assert 1 <= h <= 10**9

assert max(H) <= D <= 10**9

ok = ''
if N <= 16: ok += '1'

if N <= 50:
    dp = [ 0 for n in range(N+1) ]
    dp[0] = 1
    for n in range(1,N+1):
        for p in range(n):
            if sum(H[p:n]) <= D:
                dp[n] += dp[p]
    if dp[N] <= 10**6: ok += '2'

if N <= 1000: ok += '3'
if N <= 100000 and D <= 10: ok += '4'
if N <= 500000: ok += '5'

assert ok != ''

print('OK', ok)
